% Testing ground. Do not use - may not work.

%close all
clear

global g_zero g_angle

g_zero = (100*eps);

% Grid cell size.
gcs = [64; 64];
ngx = 10;
ngy = 10;
ng = [ngx; ngy];

% Texture.
%texture = rand( gcs(1), gcs(2), 3 );
texture = imread( 'giveup.jpg' );
texture = double(texture) / double(max(max(max(texture))));

% Observer point.
op = [221; 350];

% View direction angle.
oa = 0;

% Field of view semiangle.
fov.a = 30;

% Field of view size.
fov.s = [200; 100];

% Field of view screen distance.
fov.sd = 0.5 * fov.s(1) / tan( pi / 180 * fov.a );

% Field of view image.
fov.img = zeros( fov.s(2), fov.s(1), 3 );

fov

% Compute ray line angles.
aux = fov.s(1) / 2;
for i = 1:fov.s(1)
  g_angle(i) = -180 / pi * atan( (i - aux) / fov.sd );
end

% Create scale map.
smap.lmin = 1;
smap.lmax = 400;
smap.map = create_scale_map_range( gcs(2), smap.lmin, smap.lmax );

% Observer point in grid coordinates.
opg = floor( op ./ gcs );

% Local grid origin.
lgo = opg .* gcs

% Local observer point.
lop = op - lgo

% Grid.
grid = round( rand( ngx, ngy ) - 0.3 );
% $$$ grid = round( zeros( ngx, ngy ) );
% $$$ grid(5,1) = 1;
% $$$ grid(5,2) = 1;
grid( opg(2) + 1, opg(1) + 1 ) = 0;

ni = 0;

p = zeros( 2, 1 );

h_3d = figure( 1 );
clf
h_img = image( fov.img );
pos = get( h_3d, 'position' );
set( h_3d, 'backingstore', 'off', 'menubar', 'none',...
    'position', [pos(1), pos(2), fov.s(1), fov.s(2)] );
set( h_img, 'erasemode', 'none', 'clipping', 'off' );
set( gca, 'position', [0, 0, 1, 1] );
axis equal
axis off
hold on
h_map = figure( 2 );
while (1)
  plot_map( h_map, op, oa, grid, gcs, ng, fov );
  [ni, fov] = render_maze( op, oa, grid, gcs, ng, smap, texture, fov );
  % Show maze.
  set( h_img, 'cdata', fov.img );
  drawnow

  [p(1), p(2), b] = ginput( 1 );
  if (any( [p(1) <= 0, p(2) <= 0,...
	  p(1) > (gcs(1) * ng(1)), p(2) > (gcs(2) *ng(2))] ))
    break;
  end
  if (b == 1)
    op = p;
  else
    oa = (1-2*(p(2) < op(2)))...
	* 180 / pi * acos( (p(1) - op(1)) / norm( p - op ) );
  end
  [op(:)' oa ni]
end
